//Client_Hub
//An alternative to the main menu
//Author: Lilboarder

//Execute other scripts
exec("./HubAddOnsGui.gui");
exec("./HubAddons.cs");


//Set default prefs
if(!strLen($Pref::Hub::HubMap))
{
	$Pref::Hub::HubMapName = "Skylands";
}
if(!isFile($Pref::Hub::HubSave))
{
	$Pref::Hub::HubSave = findFirstFile("saves/Hub/*.bls");
	%String = strReplace($Pref::Hub::HubSave,"/","\t");
	%String = getField(%String,getFieldCount(%String) - 1);
	%String = getSubStr(%String,0,strLen(%String) - 4);
	$Pref::Hub::HubSaveName = %String;
}
if(!isFile("Config/Client/HubAddonList.cs"))
{
	loadHubAddons();
	HAOG_clickDefault();
	export("$HubAddon::*","Config/Client/HubAddonList.cs");
}
else
{
	exec("Config/Client/HubAddonList.cs");
}
if($Pref::Hub::startHub $= "")
{
	$Pref::Hub::startHub = 1;
}

if(!$Hub::GuiEdits)
{
	//Load Add-Ons into the HubAddOnsGui

	startMissionGui.getObject(0).getObject(17).command = "SM_StartMissionEdit();";

	%Hub = new GuiBitmapButtonCtrl(EM_GoToHub)
	{
		profile = "BlockButtonProfile";
		horizSizing = "center";
		vertSizing = "bottom";
		position = "7 293";
		extent = "207 36";
		minExtent = "8 2";
		visible = "1";
		command = "escapeToHub();";
		text = "Go To Hub";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "base/client/ui/button1";
		lockAspectRatio = "0";
		alignLeft = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = "255 200 0 255";
	};
	escapeMenu.getObject(0).add(%Hub);
	%HubStart = new GuiCheckBoxCtrl(OptHUBStartup)
	{
		profile = "GuiCheckBoxProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "214 21";
		extent = "140 30";
		minExtent = "8 2";
		visible = 1;
		variable = "$Pref::Hub::StartHub";
		command = "";
		text = "Go To HUB Upon Start";
		groupNum = -1;
		buttonType = "ToggleButton";
	};
	OptAdvGraphicsPane.getObject(2).getObject(0).getObject(3).add(%HubStart);
	%HubSave = new GuiTextCtrl()
	{
		profile = "GuiTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "205 42";
		extent = "77 18";
		minExtent = "8 2";
		visible = 1;
		text = "Hub Save Name";
		maxLength = "255";
	};
	OptAdvGraphicsPane.getObject(2).getObject(0).getObject(3).add(%HubSave);
	%HubSaveText = new GuiTextEditCtrl(OptHubSaveName)
	{
		profile = "GuiTextEditProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "286 42";
		extent = "64 18";
		minExtent = "8 2";
		command = "typeHubSave(OptHubSaveName.getValue());";
		visible = 1;
		variable = "$Pref::Hub::HubSaveName";
		maxLength = "255";
		historySize = 0;
	};
	OptAdvGraphicsPane.getObject(2).getObject(0).getObject(3).add(%HubSaveText);
	%HubMap = new GuiTextCtrl()
	{
		profile = "GuiTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "382 26";
		extent = "72 18";
		minExtent = "8 2";
		visible = 1;
		text = "Hub Map Name";
		maxLength = "255";
	};
	OptAdvGraphicsPane.getObject(2).getObject(0).getObject(3).add(%HubMap);
	%HubMapPop = new GuiPopUpMenuCtrl(OptHubMapName)
	{
		profile = "GuiPopUpMenuProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "459 26";
		extent = "82 20";
		minExtent = "8 2";
		visible = 1;
		command = "selectHubMap(OptHubMapName.getTextByID(OptHubMapName.getSelected()));";
		variable = "$Pref::Hub::HubMap";
		maxLength = "255";
		maxPopupHeight = "200";
	};
	OptAdvGraphicsPane.getObject(2).getObject(0).getObject(3).add(%HubMapPop);
	%HubAddonsGui = new GuiBitmapButtonCtrl()
	{
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "top";
		position = "500 366";
		extent = "113 19";
		minExtent = "8 2";
		visible = 1;
		command = "canvas.pushDialog(HubAddOnsGui);";
		text = "Hub Add-Ons";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "base/client/ui/button1";
		lockAspectRation = 0;
		alignLeft = 0;
		overflowImage = 0;
		mKeepCached = 0;
		mColor = "255 255 255 255";
		wrap = 0;
	};
	startMissionGui.getObject(0).add(%HubAddonsGui);
	%GoToHub = new GuiBitmapButtonCtrl()
	{
		profile = "BlockButtonProfile";
		horizSizing = "left";
		vertSizing = "top";
		position = "499 340";
		extent = "105 18";
		minExtent = "8 2";
		visible = 1;
		command = "goToHub();";
		text = "Go To Hub >>";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "base/client/ui/button1";
		lockAspectRation = 0;
		alignLeft = 0;
		overflowImage = 0;
		mKeepCached = 0;
		mColor = "255 255 255 255";
		wrap = 0;
	};
	startMissionGui.getObject(0).add(%GoToHub);

	EM_PlayerList.position = "7 79";
	EM_MiniGames.position = "7 119";
	EM_AdminMenu.position = "7 159";
	EM_SaveBricks.position = "7 207";
	EM_LoadBricks.position = "7 247";
	EM_Disconnect.position = "7 333";
	EM_Quit.position = "7 373";
	$Hub::GuiEdits = 1;
}

package BlocklandHub
{
	function disconnect()
	{
		restoreOriginalAddons();
		Parent::disconnect();
		$BotEventsLoaded = 0;
		$HubServer = 0;
	}
	function canvas::setContent(%this, %gui)
	{
		parent::setContent(%this, %gui);
		if(%gui.getName() $= "MainMenuGUI" && !$BlockedMainMenu && $Pref::Hub::StartHub)
		{
			restoreOriginalAddons();
			schedule(1000, 0, goToHub);
		}
		else if(%gui.getName() $= "MainMenuGUI")
		{
			restoreOriginalAddons();
		}
	}
	function JoinServerGUI::join(%this)
	{
		if(isObject(localClientConnection))
		{
			disconnect();
			JoinServerGUI.schedule(200, join);
		}
		else
		{
			parent::join(%this);
		}
	}
	function GameConnection::onClientEnterGame(%this)
	{
		if($Server::ServerType $= "SinglePlayer" && $HubServer)
		{
			exec("./Events.cs");
			if(isFile($Pref::Hub::HubSave))
			{
				schedule(100, 0, serverDirectSaveFileLoad, $Pref::Hub::HubSave, 3, "", 0, 1); //name, colormethod, directory, dotrust, silent
			}
			$MapSaveName = "Hub";
			$Hub::Client = %this;
		}
		Parent::onClientEnterGame(%this);
	}
	function escapeMenu::onWake(%this)
	{
		if(!$Pref::Gui::ColorEscapeMenu)
		{
			EM_GoToHub.mColor = "255 255 255 255";
		}
		else
		{
			EM_GoToHub.mColor = "255 200 0 255";
		}
		Parent::onWake(%this);
	}
	function optionsDlg::onWake(%this)
	{
		Parent::onWake(%this);
		if(!$OptionsDlgWake)
		{
			%MapName = findFirstFile("Add-Ons/*.mis");
			OptHubMapName.addFront(getMissionDisplayName(%MapName),0);
			while((%MapName = findNextFile("Add-Ons/*.mis")) !$= "")
			{
				%String = strReplace(%MapName,"/","\t");
				for(%i=0;%i<getFieldCount(%String);%i++)
				{
					%Field = getField(%String,%i);
					if(%Field $= "__MACOSX")
					{
						%MacOsX = 1;
					}
				}
				if(%MacOsX)
				{
					%MacOsX = 0;
					continue;
				}
				%MapDisplayName = getMissionDisplayName(%MapName);
				OptHubMapName.addFront(%MapDisplayName,%a++);
			}
			$OptionsDlgWake = 1;
		}
	}
	function AddonsGui::onWake(%this)
	{
		restoreOriginalAddons();
		parent::onWake(%this);
	}
	function fxDtsBrick::onPlant(%this)
	{
		parent::onPlant(%this);
		if(%this.getDatablock().getName() $= "brickSpawnPointData" && $Server::ServerType $= "SinglePlayer" && $HubServer && isObject(%client = $Hub::Client))
		{
			if(!%client.hasSpawnPointSpawned)
			{
				%client.instantRespawn();
				%client.hasSpawnPointSpawned = 1;
			}
		}
	}
};
activatePackage(BlocklandHub);

function HubAddonsGui::onSleep(%this)
{
	export("$HubAddon::*","Config/Client/HubAddonList.cs");
}
function HubAddonsGui::onWake(%this)
{
	loadHubAddons();
}
function selectHubMap(%map)
{
	OptHubMapName.setText(%map);
	$Pref::Hub::HubMapName = %map;
}
function typeHubSave(%Save)
{
	$Pref::Hub::HubSaveName = %Save;
	$Pref::Hub::HubSave = "saves/Hub/"@ %Save @".bls";
}
function SM_StartMissionEdit()
{
	if(isObject(serverConnection))
	{
		disconnect();
		schedule(1000,0,SM_StartMission);
	}
	else
	{
		SM_StartMission();
	}
}
function escapeToHub()
{
	if(isObject(serverConnection))
	{
		if(serverConnection.isLocalConnection())
		{
			if($Server::ServerType !$= "SinglePlayer")
			{
				messageBoxYesNo("Disconnect", "Stop hosting server and go to hub?", "GoToHub();","");
			}
			else if($HubServer)
			{
				messageBoxOk("Disconnect", "You are already in your hub!");
			}
		}
		else
		{
			messageBoxYesNo("Disconnect", "Disconnect from server and go to hub?", "GoToHub();","");
		}
	}
	else
	{
		GoToHub();
	}
}
function GoToHub()
{
	$BlockedMainMenu = 1;
	disconnect();
	convertToHubAddons();
	schedule(1000,0,finishGoToHub);
}
function finishGoToHub()
{
	//Messing with start mission GUI to set everything up right
	canvas.pushDialog(StartMissionGUI);
	startMissionGui.ClickSinglePlayer();
	%count = SM_MissionList.rowCount();
	for(%i = 1; %i < %count; %i++)
	{
		if(getField(SM_MissionList.getRowTextById(%i), 0) $= $Pref::Hub::HubMapName)
		{
			SM_MissionList.setSelectedByID(%i);
		}
	}
	SM_MissionList.select();
	schedule(100,0,SM_StartMission);
	$HubServer = 1;
	schedule(2000,0,restoreOriginalAddons);
}